import sys
import logging
import pymysql
import boto3
import json

#rds settings
rds_proxy_host = "proxy_name.proxy-xxxx.region.rds.amazonaws.com"
name = "admin"
password = "pass"
db_name = "object_detect_db"
table_name = "results"

logger = logging.getLogger()
logger.setLevel(logging.INFO)

try:
    conn = pymysql.connect(host=rds_proxy_host, user=name, passwd=password, db=db_name, connect_timeout=5)
except pymysql.MySQLError as e:
    logger.error("ERROR: Unexpected error: Could not connect to MySQL instance.")
    logger.error(e)
    sys.exit()

logger.info("SUCCESS: Connection to RDS MySQL instance succeeded")

def create_table():
    with conn.cursor() as cur:
        cur.execute("create table if not exists " + table_name 
        + " (timestamp datetime, class_id varchar(20), score float, gateway_id varchar(16), camera_id int)")
        conn.commit()

def insert_data(data_list):
    for data in data_list:
        objects = data["object"]
        for obj in objects:

            str = "insert into {} (timestamp, class_id, score, gateway_id, camera_id) values(\"{}\", \"{}\", {}, \"{}\", {})".format(
                table_name, data["timestamp"], obj["class_id"], obj["score"], data["gateway_id"], data["camera_id"])
            print(str)
            with conn.cursor() as cur:
                cur.execute(str)
                conn.commit()
    
def lambda_handler(event, context):
    
    print(event)
    
    if 'state' in event:
        data_list = event['state']['desired']['property']
        print(data_list)
        create_table()
        insert_data(data_list)

    return "object detect into RDS"